/* gencodeTag.c was originally generated by the autoSql program, which also 
 * generated gencodeTag.h and gencodeTag.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "gencodeTag.h"



char *gencodeTagCommaSepFieldNames = "transcriptId,tag";

void gencodeTagStaticLoad(char **row, struct gencodeTag *ret)
/* Load a row from gencodeTag table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->transcriptId = row[0];
ret->tag = row[1];
}

struct gencodeTag *gencodeTagLoad(char **row)
/* Load a gencodeTag from row fetched with select * from gencodeTag
 * from database.  Dispose of this with gencodeTagFree(). */
{
struct gencodeTag *ret;

AllocVar(ret);
ret->transcriptId = cloneString(row[0]);
ret->tag = cloneString(row[1]);
return ret;
}

struct gencodeTag *gencodeTagLoadAll(char *fileName) 
/* Load all gencodeTag from a whitespace-separated file.
 * Dispose of this with gencodeTagFreeList(). */
{
struct gencodeTag *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileRow(lf, row))
    {
    el = gencodeTagLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct gencodeTag *gencodeTagLoadAllByChar(char *fileName, char chopper) 
/* Load all gencodeTag from a chopper separated file.
 * Dispose of this with gencodeTagFreeList(). */
{
struct gencodeTag *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = gencodeTagLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct gencodeTag *gencodeTagCommaIn(char **pS, struct gencodeTag *ret)
/* Create a gencodeTag out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new gencodeTag */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->transcriptId = sqlStringComma(&s);
ret->tag = sqlStringComma(&s);
*pS = s;
return ret;
}

void gencodeTagFree(struct gencodeTag **pEl)
/* Free a single dynamically allocated gencodeTag such as created
 * with gencodeTagLoad(). */
{
struct gencodeTag *el;

if ((el = *pEl) == NULL) return;
freeMem(el->transcriptId);
freeMem(el->tag);
freez(pEl);
}

void gencodeTagFreeList(struct gencodeTag **pList)
/* Free a list of dynamically allocated gencodeTag's */
{
struct gencodeTag *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    gencodeTagFree(&el);
    }
*pList = NULL;
}

void gencodeTagOutput(struct gencodeTag *el, FILE *f, char sep, char lastSep) 
/* Print out gencodeTag.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->transcriptId);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->tag);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

